1. Two Sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

Boring brushing leetcode.
Found that the subject is a company interview topic.

This problem mainly use unordered_map .

unordered_map allow two or more apper in data.but is  not ordered.

this is  my solutation:

class Solution {
public:
    vector<int> twoSum(vector<int>& nums, int target) {
        unordered_map<int, int> mp;
        vector<int> v;
        for (int i = 0; i < nums.size(); ++i ){
            int  x = target - nums[i];
            if (mp.count(x) > 0) {
                v.push_back((mp.find(x))->second);
                v.push_back(i);
                break;
            }
            mp.insert({nums[i],i});
        }
        return v;
    }
};

 

o(n)

STL中,map对应的数据结构是红黑树。红黑树是一种近似于平衡的二叉查找树,里面的数据是有序的。在红黑树上做查找操作的时间复杂度为 O(logN)。而unordered_map对应 哈希表,哈希表的特点就是查找效率高,时间复杂度为常数级别 O(1), 而额外空间复杂度则要高出许多。所以对于需要高效率查询的情况,使用unordered_map容器。而如果对内存大小比较敏感或者数据存储要求有序的话,则可以用map容器。 

posted on 2017-07-04 22:21  Beserious  阅读(129)  评论(0编辑  收藏  举报